# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define section free

Name:           maven-jdocbook-plugin
Version:        2.1.2
Release:        3%{?dist}
Epoch:          0
Summary:        jDocBook Maven Plugin
License:        LGPLv2+
Group:          Development/Tools
URL:            http://www.jboss.org/maven-jdocbook-plugin/
# svn export http://anonsvn.jboss.org/repos/labs/labs/jbossbuild/maven-plugins/tags/maven-jdocbook-plugin-2.1.2/
Source0:        maven-jdocbook-plugin-2.1.2.tar.gz
Source1:        maven-jdocbook-plugin-settings.xml
Source2:        maven-jdocbook-plugin-jpp-depmap.xml
Patch0:         maven-jdocbook-plugin-ResourceMojo.patch
Patch1:         maven-jdocbook-plugin-pom.patch
Patch2:         maven-jdocbook-plugin-docbook-xsl.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       maven2
Requires:       docbook-xsl >= 0:1.75.2
Requires:       docbook-xsl-saxon >= 0:1.0.0
Requires:       java >= 0:1.5.0
Requires:       jboss-parent >= 0:4
Requires:       jpackage-utils
Requires:       saxon >= 0:6.5.3
Requires:       xalan-j2 >= 0:2.7.0
Requires:       xml-commons-jaxp-1.3-apis
Requires:       xml-commons-resolver11
Requires:       xmlgraphics-batik >= 0:1.7
Requires:       xmlgraphics-fop >= 0:0.95
BuildRequires:  apache-commons-parent >= 0:5
BuildRequires:  docbook-xsl >= 0:1.75.2
BuildRequires:  docbook-xsl-saxon >= 0:1.0.0
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jboss-parent >= 0:4
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  saxon >= 6.5.3
BuildRequires:  xalan-j2 >= 0:2.7.0
BuildRequires:  xerces-j2 >= 0:2.9.1
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xml-commons-resolver11
BuildRequires:  xmlgraphics-batik >= 0:1.7
BuildRequires:  xmlgraphics-fop >= 0:0.95
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
DocBook is, in part, "an XML vocabulary that lets you create
documents in a presentation-neutral form that captures the
logical structure of your content". Another aspect of DocBook
is the rendering of that content into various formats using
DocBook-supplied (or custom) XSLT stylesheets. Basically,
DocBook allows you to write and maintain a single source for
documentation, and to then render that single source into
multiple formats such as PDF or HTML.

The purpose of the jDocBook Plugin is to allow these DocBook
transformations to occur as a natural part of the users Maven
build. The main difficulty with this has always been the fact
that DocBook transformations are usually very closely tied to
the user's local environment. The design goal with writing
this plugin was to utilize Maven's dependency mechanism to
bring all the pieces together on demand. Those pieces are:

1. the DocBook distribution;
2. custom XSLT;
3. custom fonts;
4. custom images;
5. custom css.

These are the ingredients that when mixed with the source
file(s) and stirred with an XSLT transformer produce the
desired output(s).

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2

%{__cp} -p %{SOURCE1} settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml

%{__mkdir} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%build
export M2_SETTINGS=$(pwd)/settings.xml
%{_bindir}/mvn-jpp \
        -e \
        -s ${M2_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        deploy javadoc:javadoc

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p target/%{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

# poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.maven.plugins maven-jdocbook-plugin %{version} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
# repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*/
%exclude %dir %{_javadocdir}/
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Sat Jan 22 2011 David Walluck <dwalluck@redhat.com> 0:2.1.2-3
- update docbook-xsl patch

* Fri Jan 21 2011 David Walluck <dwalluck@redhat.com> 0:2.1.2-2
- add patch for upstream docbook-xsl
- add repolib
- patch POM to use upstream docbook XML POMs
- BuildRequires: maven2-plugin-release
- remove Requires: jbossorg-docbook-xslt, jbossorg-jdocbook-style
- fix maven depmap
- fix file list for brew
- copy pom with correct permissions
- Requires: jbossorg-docbook-xslt
- Requires: jbossorg-jdocbook-style
- Adjust dependencies to EAP project

* Thu Dec 18 2008 Ralph Apel <r.apel@r-apel.de> 0:2.1.2-1.jpp5
- First release
